/* Automatically generated from Squeak on #(2 July 2001 1:26:28 pm) */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/* Default EXPORT macro that does nothing (see comment in sq.h): */
#define EXPORT(returnType) returnType

/* Do not include the entire sq.h file but just those parts needed. */
/*  The virtual machine proxy definition */
#include "sqVirtualMachine.h"
/* Configuration options */
#include "sqConfig.h"
/* Platform specific definitions */
#include "sqPlatformSpecific.h"

#define true 1
#define false 0
#define null 0  /* using 'null' because nil is predefined in Think C */
#include <sys/types.h>
/* D T Lewis 2001 - UnixOSProcessPlugin.c translated from class UnixOSProcessPlugin */
#include <sys/time.h>
#include <sys/wait.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <errno.h>
#include "sq.h"
#include "FilePlugin.h"
#include "SocketPlugin.h"

/* memory access macros */
#define byteAt(i) (*((unsigned char *) (i)))
#define byteAtput(i, val) (*((unsigned char *) (i)) = val)
#define longAt(i) (*((int *) (i)))
#define longAtput(i, val) (*((int *) (i)) = val)

/*** Variables ***/
struct VirtualMachine* interpreterProxy;
const char *moduleName = "UnixOSProcessPlugin 2 July 2001 (e)";
int sigChldSemaIndex;

/*** Function Prototypes ***/
static char * cStringFromString(int aString);
static int descriptorTableSize(void);
static void dupToStdErr(int anSQFileDataStructure);
static void dupToStdIn(int anSQFileDataStructure);
static void dupToStdOut(int anSQFileDataStructure);
static int fileDescriptorFrom(int aFileHandle);
static int fileRecordSize(void);
static SQFile * fileValueOf(int anSQFileRecord);
static int fixPointersInArrayOfStringswithOffsetscount(char *flattenedArrayOfStrings, int *offsetArray, int count);
#pragma export on
EXPORT(const char*) getModuleName(void);
#pragma export off
static int newSQFileByteArray(void);
static int newSQSocketByteArray(void);
static int primFixPointersInArrayOfStringswithOffsetscount(int cStringArray, int offsetArray, int count);
#pragma export on
EXPORT(void) primitiveArgumentAt(void);
EXPORT(void) primitiveCanReceiveSignals(int anIntegerPid);
EXPORT(void) primitiveChdir(void);
EXPORT(void) primitiveEnvironmentAt(void);
EXPORT(void) primitiveEnvironmentAtSymbol(void);
EXPORT(void) primitiveErrorMessageAt(void);
EXPORT(void) primitiveFileProtectionMask(void);
EXPORT(void) primitiveFileStat(void);
EXPORT(int) primitiveFixPointersInArrayOfStrings(void);
EXPORT(void) primitiveForkAndExec2(void);
EXPORT(void) primitiveForkAndExecClosingAll(void);
EXPORT(void) primitiveForkAndExecInDirectory(void);
EXPORT(void) primitiveForkHeadlessSqueak(void);
EXPORT(void) primitiveForkSqueak(void);
EXPORT(void) primitiveGetCurrentWorkingDirectory(void);
EXPORT(void) primitiveGetEGid(void);
EXPORT(void) primitiveGetEUid(void);
EXPORT(void) primitiveGetGid(void);
EXPORT(void) primitiveGetPPid(void);
EXPORT(void) primitiveGetPid(void);
EXPORT(void) primitiveGetSession(void);
EXPORT(void) primitiveGetStdErrHandle(void);
EXPORT(void) primitiveGetStdInHandle(void);
EXPORT(void) primitiveGetStdOutHandle(void);
EXPORT(void) primitiveGetUid(void);
EXPORT(void) primitiveKillDisplay(void);
EXPORT(void) primitiveMakePipe(void);
EXPORT(void) primitiveOpenXDisplay(void);
EXPORT(void) primitivePutEnv(void);
EXPORT(void) primitiveRealpath(void);
EXPORT(void) primitiveReapChildProcess(void);
EXPORT(void) primitiveRename(void);
EXPORT(void) primitiveSQFileFlush(void);
EXPORT(void) primitiveSQFileSetBlocking(void);
EXPORT(void) primitiveSQFileSetNonBlocking(void);
EXPORT(void) primitiveSQFileSetUnbuffered(void);
EXPORT(void) primitiveSendSigabrtTo(int anIntegerPid);
EXPORT(void) primitiveSendSigalrmTo(int anIntegerPid);
EXPORT(void) primitiveSendSigchldTo(int anIntegerPid);
EXPORT(void) primitiveSendSigcontTo(int anIntegerPid);
EXPORT(void) primitiveSendSighupTo(int anIntegerPid);
EXPORT(void) primitiveSendSigintTo(int anIntegerPid);
EXPORT(void) primitiveSendSigkillTo(int anIntegerPid);
EXPORT(void) primitiveSendSigpipeTo(int anIntegerPid);
EXPORT(void) primitiveSendSigquitTo(int anIntegerPid);
EXPORT(void) primitiveSendSigstopTo(int anIntegerPid);
EXPORT(void) primitiveSendSigtermTo(int anIntegerPid);
EXPORT(void) primitiveSendSigusr1To(int anIntegerPid);
EXPORT(void) primitiveSendSigusr2To(int anIntegerPid);
EXPORT(void) primitiveSetSemaIndex(void);
EXPORT(int) primitiveSizeOfInt(void);
EXPORT(int) primitiveSizeOfPointer(void);
EXPORT(int) primitiveUnixFileClose(int anIntegerFileNumber);
EXPORT(int) primitiveUnixFileNumber(void);
#pragma export off
static void reapChildProcess(int sigNum);
static void restoreDefaultSignalHandlers(void);
static int sandboxSecurity(void);
#pragma export on
EXPORT(int) setInterpreter(struct VirtualMachine* anInterpreter);
#pragma export off
static void setSigChldHandler(void);
static void setSigPipeHandler(void);
static int socketRecordSize(void);
static SQSocket * socketValueOf(int anSQSocketRecord);
static int stringFromCString(char *aCString);


/*	Answer a new null-terminated C string copied from aString.
	Caution: This may invoke the garbage collector. */

static char * cStringFromString(int aString) {
    char *stringPtr;
    int newString;
    int len;
    char *cString;

	len = interpreterProxy->sizeOfSTArrayFromCPrimitive(interpreterProxy->arrayValueOf(aString));

	/* Allocate space for a null terminated C string. */

	stringPtr = interpreterProxy->arrayValueOf(aString);
	newString = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classString(), len + 1);

	/* Point to the actual C string. */

	cString = interpreterProxy->arrayValueOf(newString);
	(char *)strncpy(cString, stringPtr, len);
	cString[len] = 0;
	return cString;
}


/*	Answer the size of the file descriptor table for a process. I am not sure of the most portable
	way to do this. If this implementation does not work on your Unix platform, try changing
	it to answer the value of FOPEN_MAX, which will hopefully be defined in stdio.h. If
	all else fails, just hard code it to answer 20, which would be safe for any Unix. */

static int descriptorTableSize(void) {
	return getdtablesize();
}


/*	Dup a file descriptor to allow it to be attached as the standard error when we
	exec() a new executable. This is Unix specific, in that it assumes that file descriptor
	0 is stdin, 1 is stdout, and 2 is stderr. The dup2() call is used to copy the open file
	descriptors into file descriptors 0, 1 and 2 so that the image which we execute will
	use them as stdin, stdout, and stderr. This should be called only from within a
	primitive. It is not intended to be called as a Smalltalk method. */

static void dupToStdErr(int anSQFileDataStructure) {
    int filenoToDup;

	filenoToDup = fileDescriptorFrom(anSQFileDataStructure);
	if (!(filenoToDup < 0)) {
		if (!(filenoToDup == 2)) {
			fflush(stderr);
			dup2(filenoToDup, 2);
		}
	}
}


/*	Dup a file descriptor to allow it to be attached as the standard input when we
	exec() a new executable. This is Unix specific, in that it assumes that file descriptor
	0 is stdin, 1 is stdout, and 2 is stderr. The dup2() call is used to copy the open file
	descriptors into file descriptors 0, 1 and 2 so that the image which we execute will
	use them as stdin, stdout, and stderr. This should be called only from within a
	primitive. It is not intended to be called as a Smalltalk method. */

static void dupToStdIn(int anSQFileDataStructure) {
    int filenoToDup;

	filenoToDup = fileDescriptorFrom(anSQFileDataStructure);
	if (!(filenoToDup < 0)) {
		if (!(filenoToDup == 0)) {
			fflush(stdin);
			dup2(filenoToDup, 0);
			rewind(stdin);
		}
	}
}


/*	Dup a file descriptor to allow it to be attached as the standard output when we
	exec() a new executable. This is Unix specific, in that it assumes that file descriptor
	0 is stdin, 1 is stdout, and 2 is stderr. The dup2() call is used to copy the open file
	descriptors into file descriptors 0, 1 and 2 so that the image which we execute will
	use them as stdin, stdout, and stderr. This should be called only from within a
	primitive. It is not intended to be called as a Smalltalk method. */

static void dupToStdOut(int anSQFileDataStructure) {
    int filenoToDup;

	filenoToDup = fileDescriptorFrom(anSQFileDataStructure);
	if (!(filenoToDup < 0)) {
		if (!(filenoToDup == 1)) {
			fflush(stdout);
			dup2(filenoToDup, 1);
		}
	}
}


/*	Answer the OS file descriptor, an integer value, from a SQFile data structure,
	or answer -1 if unable to obtain the file descriptor (probably due to receiving
	an incorrect type of object as aFileHandle). This method may be called from a
	primitive, and is not intended to be called from Smalltalk. */

static int fileDescriptorFrom(int aFileHandle) {
    FILE *osFileStream;
    SQFile * sqFile;

	/* begin fileValueOf: */
	if ((interpreterProxy->isBytes(aFileHandle)) && ((interpreterProxy->byteSizeOf(aFileHandle)) == (fileRecordSize()))) {
		sqFile = arrayValueOf(aFileHandle);
		goto l1;
	} else {
		primitiveFail();
		sqFile = null;
		goto l1;
	}
l1:	/* end fileValueOf: */;
	if (sqFile == 0) {
		return -1;
	} else {
		osFileStream = sqFile->file;
		return fileno(osFileStream);
	}
}


/*	Answer the size of a SQFile data structure in bytes. */

static int fileRecordSize(void) {
	return sizeof(SQFile);
}


/*	Return a pointer to the first byte of of the SQFile data structure file record within
	anSQFileRecord, which is expected to be a ByteArray of size self>>fileRecordSize. */

static SQFile * fileValueOf(int anSQFileRecord) {
	if ((interpreterProxy->isBytes(anSQFileRecord)) && ((interpreterProxy->byteSizeOf(anSQFileRecord)) == (fileRecordSize()))) {
		return arrayValueOf(anSQFileRecord);
	} else {
		primitiveFail();
		return null;
	}
}


/*	Use the address offsets in offsetArray to fix up the pointers in cStringArray.
	The result is a C array of pointers to char, used for argv and env vectors. */

static int fixPointersInArrayOfStringswithOffsetscount(char *flattenedArrayOfStrings, int *offsetArray, int count) {
    int idx;
    char **ptr;

	ptr = ((char **) flattenedArrayOfStrings);
	idx = 0;
	while (idx < count) {
		ptr[idx] = (flattenedArrayOfStrings + (((offsetArray[idx]) >> 1)));
		idx += 1;
	}
}


/*	Note: This is hardcoded so it can be run from Squeak.
	The module name is used for validating a module *after*
	it is loaded to check if it does really contain the module
	we're thinking it contains. This is important! */

EXPORT(const char*) getModuleName(void) {
	return moduleName;
}


/*	Answer a new ByteArray sized to contain a SQFile data structure. */

static int newSQFileByteArray(void) {
	return interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), fileRecordSize());
}


/*	Answer a new ByteArray sized to contain a SQSocket data structure. */

static int newSQSocketByteArray(void) {
	return interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), socketRecordSize());
}


/*	This primitive call exists only for purposes of testing the
	fixPointersInArrayOfStrings:withOffsets:count: method. I believe it to be
	reasonably machine and compiler independent, but have no way of verifying
	this on a variety of machines, so I'll leave this test method here in case
	someone runs into problems on other hardware or compilers. -dtl */
/*	| a |
	a _ OSProcess thisOSProcess envAsFlatArrayAndOffsets: UnixProcess env.
	UnixOSProcessPlugin new
		primFixPointersInArrayOfStrings: (a at: 1)
		withOffsets: (a at: 2)
		count: (a at: 2) size */

static int primFixPointersInArrayOfStringswithOffsetscount(int cStringArray, int offsetArray, int count) {
	return null;
}


/*	Answer a string containing the OS process argument at index (an Integer) in the
	argument list. */

EXPORT(void) primitiveArgumentAt(void) {
    extern char **argVec;
    extern int argCnt;
    int s;
    int index;
    char *sPtr;

	index = interpreterProxy->stackIntegerValue(0);
	if ((index > argCnt) || (index < 1)) {
		interpreterProxy->pop(2);
		interpreterProxy->push(interpreterProxy->nilObject());
	} else {
		sPtr = argVec[index - 1];
		s = stringFromCString(sPtr);
		interpreterProxy->pop(2);
		interpreterProxy->push(s);
	}
}


/*	Send a null signal to the OS process identified by anIntegerPid. Answer false for
	a bad parameter on the stack (the common case is for anIntegerPid equal to nil,
	for which case we should answer false). Answer true if the process exists and can
	receive signals from this process, otherwise false. This test is useful for determining
	if a child process still exists following a Squeak image restart. */

EXPORT(void) primitiveCanReceiveSignals(int anIntegerPid) {
    int pidToSignal;
    int result;

	if (((interpreterProxy->stackValue(0)) & 1)) {
		pidToSignal = interpreterProxy->stackIntegerValue(0);
		result = kill(pidToSignal, 0);
		interpreterProxy->pop(2);
		if (result == 0) {
			interpreterProxy->push(interpreterProxy->trueObject());
		} else {
			interpreterProxy->push(interpreterProxy->falseObject());
		}
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->push(interpreterProxy->falseObject());
	}
}


/*	Call chdir(2) to change current working directory to the specified path string. Answer
	nil for success, or errno on failure. */

EXPORT(void) primitiveChdir(void) {
    char *path;
    extern int errno;

	path = cStringFromString(interpreterProxy->stackObjectValue(0));
	if ((chdir(path)) == 0) {
		interpreterProxy->pop(2);
		interpreterProxy->push(interpreterProxy->nilObject());
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(errno);
	}
}


/*	Answer a string containing the OS process environment string at index (an Integer)
	in the environment list. */

EXPORT(void) primitiveEnvironmentAt(void) {
    extern char **envVec;
    int envCnt;
    int s;
    int index;
    char **p;
    char *sPtr;

	p = envVec;
	envCnt = 0;
	while (*p++) envCnt++;
	index = interpreterProxy->stackIntegerValue(0);
	if ((index > envCnt) || (index < 1)) {
		interpreterProxy->pop(2);
		interpreterProxy->push(interpreterProxy->nilObject());
	} else {
		sPtr = envVec[index - 1];
		s = stringFromCString(sPtr);
		interpreterProxy->pop(2);
		interpreterProxy->push(s);
	}
}


/*	Answer the value of an environment variable keyed by a Symbol. */

EXPORT(void) primitiveEnvironmentAtSymbol(void) {
    int s;
    char * getenvResult;
    char *keyCStringPtr;

	keyCStringPtr = cStringFromString(interpreterProxy->stackObjectValue(0));
	getenvResult = getenv(keyCStringPtr);
	if (getenvResult == 0) {
		interpreterProxy->primitiveFail();
		interpreterProxy->pop(2);
		interpreterProxy->push(interpreterProxy->nilObject());
	} else {
		s = stringFromCString(getenvResult);
		interpreterProxy->pop(2);
		interpreterProxy->push(s);
	}
}


/*	Answer a string describing an error message */

EXPORT(void) primitiveErrorMessageAt(void) {
    int errMessage;
    int index;
    char *p;

	index = interpreterProxy->stackIntegerValue(0);
	p = ((char *) (strerror(index)));
	errMessage = stringFromCString(p);
	interpreterProxy->pop(2);
	interpreterProxy->push(errMessage);
}


/*	Call stat(2) to obtain the file protection mask for a file. Answer an Array of
	four integers representing the protection mask, or answer errno on failure. The
	protection mask is four Integers, each of which may be considered an octal digit
	(0-7), with bit values 4, 2, and 1. The first digit selects the set user ID (4) and set
	group ID (2) and save text image (1) attributes. The second digit selects permissions
	for the user who owns the file: read (4), write (2), and execute (1); the third
	selects permissions for other users in the file's group, with the same values; and
	the fourth for other users not in the file's group, with the same values. */

EXPORT(void) primitiveFileProtectionMask(void) {
    struct stat *statBuf;
    char *path;
    int mode;
    extern int errno;
    int buffer;
    int result;

	buffer = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), sizeof(struct stat));
	statBuf = interpreterProxy->arrayValueOf(buffer);
	path = cStringFromString(interpreterProxy->stackObjectValue(0));
	mode = stat(path, statBuf);
	if (mode == 0) {
		mode = statBuf->st_mode;
		result = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classArray(), 4);
		interpreterProxy->stObjectatput(result, 4, (((mode & 07) << 1) | 1));
		interpreterProxy->stObjectatput(result, 3, ((((mode & 070) >> 3) << 1) | 1));
		interpreterProxy->stObjectatput(result, 2, ((((mode & 0700) >> 6) << 1) | 1));
		interpreterProxy->stObjectatput(result, 1, ((((mode & 07000) >> 9) << 1) | 1));
		interpreterProxy->pop(2);
		interpreterProxy->push(result);
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(errno);
	}
}


/*	Call stat(2) to obtain the file protection mask for a file. Answer errno on failure,
	or on success answer an array with: UID with: GID with: protectionMask. The	
	protectionMask is an Array of four integers representing the protection mask, or
	answer errno on failure. The protection mask is four Integers, each of which may
	be considered an octal digit (0-7), with bit values 4, 2, and 1. The first digit selects
	the set user ID (4) and set group ID (2) and save text image (1) attributes. The second
	digit selects permissions for the user who owns the file: read (4), write (2), and
	execute (1); the third selects permissions for other users in the file's group, with
	the same values; and the fourth for other users not in the file's group, with the
	same values. */

EXPORT(void) primitiveFileStat(void) {
    int gid;
    struct stat *statBuf;
    int mode;
    char *path;
    int mask;
    int uid;
    int result;
    extern int errno;
    int buffer;

	result = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classArray(), 3);
	uid = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), sizeof(uid_t));
	gid = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), sizeof(gid_t));
	mask = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classArray(), 4);
	buffer = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), sizeof(struct stat));
	statBuf = interpreterProxy->arrayValueOf(buffer);
	path = cStringFromString(interpreterProxy->stackObjectValue(0));
	mode = stat(path, statBuf);
	if (mode == 0) {
		mode = statBuf->st_mode;
		interpreterProxy->stObjectatput(mask, 4, (((mode & 07) << 1) | 1));
		interpreterProxy->stObjectatput(mask, 3, ((((mode & 070) >> 3) << 1) | 1));
		interpreterProxy->stObjectatput(mask, 2, ((((mode & 0700) >> 6) << 1) | 1));
		interpreterProxy->stObjectatput(mask, 1, ((((mode & 07000) >> 9) << 1) | 1));
		interpreterProxy->stObjectatput(result, 3, mask);
		interpreterProxy->stObjectatput(result, 2, (((statBuf->st_gid) << 1) | 1));
		interpreterProxy->stObjectatput(result, 1, (((statBuf->st_uid) << 1) | 1));
		interpreterProxy->pop(2);
		interpreterProxy->push(result);
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(errno);
	}
}


/*	This primitive exists only for purposes of testing the
	fixPointersInArrayOfStrings:withOffsets:count: method. I believe it to be
	reasonably machine and compiler independent, but have no way of verifying
	this on a variety of machines, so I'll leave this test method here in case
	someone runs into problems on other hardware or compilers. -dtl */

EXPORT(int) primitiveFixPointersInArrayOfStrings(void) {
    int cStringArray;
    int *offsets;
    int count;
    int offsetArray;
    char *flattenedArrayOfStrings;

	count = interpreterProxy->stackIntegerValue(0);
	offsetArray = interpreterProxy->stackObjectValue(1);
	cStringArray = interpreterProxy->stackObjectValue(2);
	offsets = interpreterProxy->firstIndexableField(offsetArray);
	flattenedArrayOfStrings = interpreterProxy->arrayValueOf(cStringArray);
	fixPointersInArrayOfStringswithOffsetscount(flattenedArrayOfStrings, offsets, count);
	interpreterProxy->pop(4);
	interpreterProxy->push(cStringArray);
}


/*	Fork a child OS process, and do an exec in the child. The parent continues on in
	Smalltalk, and this method answers the pid of the child which was created.

	In this implementation, memory for the argument and environment arrays is allocated
	in the image prior to calling this primitive. This allows us to avoid invoking the
	garbage collector in this primitive (thereby moving the locations of environment
	and argument memory), but comes at the cost of twiddling C pointers here in the
	primitive. An alternative to this whole mess is just to malloc the environment and
	argument vectors, but I think it is a good idea to avoid malloc as much as possible
	so as not to limit future ObjectMemory implementations.

	This primitive replaces #primitiveForkAndExec from earlier versions of the plugin.
	The new name permits backward compatibility for an image running on a VM
	which does not yet have the updated plugin. This implementation uses a different
	argument format on the stack, and differs functionally in that the child now closes
	all file descriptors (including sockets) not required (that is, everything except stdin,
	stdout, and stderr on descriptors 0, 1 and 2). This eliminates some flakey behavior
	in child processes connected to Squeak by pipes, which failed to exit at expected times
	due to the old file descriptors remaining open. This is also cleaner in that garbage
	descriptors are not left hanging around the the child.

	On entry, the stack contains:
		0: envOffsets, an array of integers for calculating environment string address offsets.
		1: envVecBuffer, a String buffer containing environment strings arranged to look like char **.
		2: argOffsets, an array of integers for calculating argument string address offsets.
		3: argVecBuffer, a String buffer containing argument strings arranged to look like char **.
		4: stdErr, a ByteArray handle.
		5: stdOut, a ByteArray handle.
		6: stdIn, a ByteArray handle.
		7: executableFile, a null terminated String with the name of the file to execute.
		8: the sender */

EXPORT(void) primitiveForkAndExec2(void) {
    int *argOffsetPtr;
    int idx;
    char **args;
    int envCount;
    int envOffsets;
    int stdOut;
    struct itimerval saveIntervalTimer;
    char **env;
    int pid;
    int *handlesToClosePtr;
    char *progNamePtr;
    char *argsPtr;
    struct itimerval intervalTimer;
    extern char **envVec;
    int envVecBuffer;
    int stdIn;
    int executableFile;
    int handleCount;
    int argCount;
    int *envOffsetPtr;
    int stdErr;
    char *envPtr;
    int argOffsets;
    int argVecBuffer;

	setSigChldHandler();
	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(9);
		interpreterProxy->pushInteger(-1);
	}
	intervalTimer.it_interval.tv_sec = 0;
	intervalTimer.it_interval.tv_usec = 0;
	intervalTimer.it_value.tv_sec = 0;
	intervalTimer.it_value.tv_usec = 0;
	setitimer (ITIMER_REAL, &intervalTimer, &saveIntervalTimer);
	if ((pid = vfork()) == 0) {
		envOffsets = interpreterProxy->stackObjectValue(0);
		envVecBuffer = interpreterProxy->stackObjectValue(1);
		argOffsets = interpreterProxy->stackObjectValue(2);
		argVecBuffer = interpreterProxy->stackObjectValue(3);
		stdErr = interpreterProxy->stackObjectValue(4);
		stdOut = interpreterProxy->stackObjectValue(5);
		stdIn = interpreterProxy->stackObjectValue(6);

		/* Pointer to name of the file to execute. */

		executableFile = interpreterProxy->stackObjectValue(7);

		/* Dup the file handles to attach the new child process to the right streams
			on descriptors 0, 1 and 2. */

		progNamePtr = interpreterProxy->arrayValueOf(executableFile);
		if (!(stdErr == (interpreterProxy->nilObject()))) {
			dupToStdErr(stdErr);
		}
		if (!(stdOut == (interpreterProxy->nilObject()))) {
			dupToStdOut(stdOut);
		}
		if (!(stdIn == (interpreterProxy->nilObject()))) {
			dupToStdIn(stdIn);
		}

		/* First Unix file descriptor after stdin, stdout, stderr. */

		idx = 3;
		handleCount = descriptorTableSize();
		while (idx < handleCount) {
			close(idx);
			idx += 1;
		}
		if (envVecBuffer == (interpreterProxy->nilObject())) {
			env = envVec;
		} else {
			envCount = interpreterProxy->stSizeOf(envOffsets);
			envPtr = interpreterProxy->arrayValueOf(envVecBuffer);
			envOffsetPtr = interpreterProxy->firstIndexableField(envOffsets);
			fixPointersInArrayOfStringswithOffsetscount(envPtr, envOffsetPtr, envCount);
			env = ((char **) envPtr);
		}
		argCount = interpreterProxy->stSizeOf(argOffsets);
		argsPtr = interpreterProxy->arrayValueOf(argVecBuffer);
		argOffsetPtr = interpreterProxy->firstIndexableField(argOffsets);
		fixPointersInArrayOfStringswithOffsetscount(argsPtr, argOffsetPtr, argCount);

		/* Clean things up before clobbering the running image. */
		/* Release shared memory for bitmap, if any. This is specific to the Unix/X
			version of Squeak. */

		args = ((char **) argsPtr);
		
#ifdef USE_XSHM
		(void *) shmExit();
#endif
		/* Extra semicolon here is an artifact of Squeak C translation */	;
		restoreDefaultSignalHandlers();
		if ((execve(progNamePtr, args, env)) == -1) {
			perror(progNamePtr);
			exit(-1);
		} else {
			/* Can't get here from there */;
		}
	} else {
		setitimer (ITIMER_REAL, &saveIntervalTimer, 0L);
		interpreterProxy->pop(9);
		interpreterProxy->pushInteger(pid);
	}
}


/*	Fork a child OS process, and do an exec in the child. The parent continues on in
	Smalltalk, and this method answers the pid of the child which was created.

	This primitive replaces #primitiveForkAndExec from earlier versions of the plugin.
	The new name permits backward compatibility for an image running on a VM
	which does not yet have the updated plugin. This implementation uses a different
	argument format on the stack, and differs functionally in that the child now closes
	all file descriptors (including sockets) not required (that is, everything except stdin,
	stdout, and stderr on descriptors 0, 1 and 2). This eliminates some flakey behavior
	in child processes connected to Squeak by pipes, which failed to exit at expected times
	due to the old file descriptors remaining open. This is also cleaner in that garbage
	descriptors are not left hanging around the the child.

	On entry, the stack contains:
		0:	stderr handle, a ByteArray
		1:	stdout handle, a ByteArray
		2:	stdin handle, aByteArray
		3:	environment, either nil or an array of null terminated strings
		4:	args, an array of null terminated strings
		5:	program name, a null terminated string
		6:	the sender */

EXPORT(void) primitiveForkAndExecClosingAll(void) {
    int argHolder;
    int idx;
    int args;
    int envCount;
    int env;
    struct itimerval saveIntervalTimer;
    int pid;
    char **argsPtr;
    char *progNamePtr;
    int argCount;
    extern char **envVec;
    struct itimerval intervalTimer;
    int handleCount;
    int envHolder;
    char **envPtr;

	setSigChldHandler();
	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(7);
		interpreterProxy->pushInteger(-1);
	}
	intervalTimer.it_interval.tv_sec = 0;
	intervalTimer.it_interval.tv_usec = 0;
	intervalTimer.it_value.tv_sec = 0;
	intervalTimer.it_value.tv_usec = 0;
	setitimer (ITIMER_REAL, &intervalTimer, &saveIntervalTimer);
	if ((pid = vfork()) == 0) {
		env = interpreterProxy->stackObjectValue(3);

		/* Dup the file handles to attach the new child process to the right streams
			on descriptors 0, 1 and 2. */

		args = interpreterProxy->stackObjectValue(4);
		if (!((interpreterProxy->stackObjectValue(0)) == (interpreterProxy->nilObject()))) {
			dupToStdErr(interpreterProxy->stackObjectValue(0));
		}
		if (!((interpreterProxy->stackObjectValue(1)) == (interpreterProxy->nilObject()))) {
			dupToStdOut(interpreterProxy->stackObjectValue(1));
		}
		if (!((interpreterProxy->stackObjectValue(2)) == (interpreterProxy->nilObject()))) {
			dupToStdIn(interpreterProxy->stackObjectValue(2));
		}

		/* First Unix file descriptor after stdin, stdout, stderr. */

		idx = 3;
		handleCount = descriptorTableSize();
		while (idx < handleCount) {
			close(idx);
			idx += 1;
		}
		if (env == (interpreterProxy->nilObject())) {
			envPtr = envVec;
		} else {
			envCount = interpreterProxy->stSizeOf(env);
			envHolder = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), (envCount + 1) * 4);
		}
		argCount = interpreterProxy->stSizeOf(args);

		/* Clean things up before clobbering the running image. */
		/* Release shared memory for bitmap, if any. This is specific to the Unix/X
			version of Squeak. */

		argHolder = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), (argCount + 1) * 4);
		
#ifdef USE_XSHM
		(void *) shmExit();
#endif
		/* Extra semicolon here is an artifact of Squeak C translation */	;
		if (!(env == (interpreterProxy->nilObject()))) {
			idx = 1;
			while (idx <= envCount) {
				envPtr[idx - 1] = (interpreterProxy->arrayValueOf(interpreterProxy->stObjectat(env, idx)));
				idx += 1;
			}
			envPtr[idx] = 0;
		}
		argsPtr = interpreterProxy->arrayValueOf(argHolder);
		idx = 1;
		while (idx <= argCount) {
			argsPtr[idx - 1] = (interpreterProxy->arrayValueOf(interpreterProxy->stObjectat(args, idx)));
			idx += 1;
		}
		argsPtr[idx] = 0;

		/* Note: If any file descriptors, signal handlers, or other references to external
			resources need to be cleaned up, do it here. */

		progNamePtr = interpreterProxy->arrayValueOf(interpreterProxy->stackObjectValue(5));
		restoreDefaultSignalHandlers();
		if ((execve(progNamePtr, argsPtr, envPtr)) == -1) {
			perror(progNamePtr);
			exit(-1);
		} else {
			/* Can't get here from there */;
		}
	} else {
		setitimer (ITIMER_REAL, &saveIntervalTimer, 0L);
		interpreterProxy->pop(7);
		interpreterProxy->pushInteger(pid);
	}
}


/*	Fork a child OS process, and do an exec in the child. The parent continues on in
	Smalltalk, and this method answers the pid of the child which was created.

	In this implementation, memory for the argument and environment arrays is allocated
	in the image prior to calling this primitive. This allows us to avoid invoking the
	garbage collector in this primitive (thereby moving the locations of environment
	and argument memory), but comes at the cost of twiddling C pointers here in the
	primitive. An alternative to this whole mess is just to malloc the environment and
	argument vectors, but I think it is a good idea to avoid malloc as much as possible
	so as not to limit future ObjectMemory implementations.

	This primitive replaces #primitiveForkAndExec from earlier versions of the plugin.
	The new name permits backward compatibility for an image running on a VM
	which does not yet have the updated plugin. This implementation uses a different
	argument format on the stack, and differs functionally in that the child now closes
	all file descriptors (including sockets) not required (that is, everything except stdin,
	stdout, and stderr on descriptors 0, 1 and 2). This eliminates some flakey behavior
	in child processes connected to Squeak by pipes, which failed to exit at expected times
	due to the old file descriptors remaining open. This is also cleaner in that garbage
	descriptors are not left hanging around the the child.

	On entry, the stack contains:
		0: workingDir, a null terminated string specifying the working directory to use, or nil.
		1: envOffsets, an array of integers for calculating environment string address offsets.
		2: envVecBuffer, a String buffer containing environment strings arranged to look like char **.
		3: argOffsets, an array of integers for calculating argument string address offsets.
		4: argVecBuffer, a String buffer containing argument strings arranged to look like char **.
		5: stdErr, a ByteArray handle.
		6: stdOut, a ByteArray handle.
		7: stdIn, a ByteArray handle.
		8: executableFile, a null terminated string with the name of the file to execute.
		9: the sender */

EXPORT(void) primitiveForkAndExecInDirectory(void) {
    int *argOffsetPtr;
    int idx;
    int pwd;
    char **args;
    int envCount;
    struct itimerval saveIntervalTimer;
    char **env;
    char *pwdPtr;
    int *handlesToClosePtr;
    char *argsPtr;
    int argCount;
    char *envPtr;
    int argOffsets;
    int workingDir;
    int envOffsets;
    int stdOut;
    int pid;
    int envVecBuffer;
    char *progNamePtr;
    extern char **envVec;
    int stdIn;
    struct itimerval intervalTimer;
    int executableFile;
    int handleCount;
    int *envOffsetPtr;
    int stdErr;
    int argVecBuffer;

	setSigChldHandler();
	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(10);
		interpreterProxy->pushInteger(-1);
	}
	intervalTimer.it_interval.tv_sec = 0;
	intervalTimer.it_interval.tv_usec = 0;
	intervalTimer.it_value.tv_sec = 0;
	intervalTimer.it_value.tv_usec = 0;
	setitimer (ITIMER_REAL, &intervalTimer, &saveIntervalTimer);
	if ((pid = vfork()) == 0) {
		workingDir = interpreterProxy->stackObjectValue(0);
		envOffsets = interpreterProxy->stackObjectValue(1);
		envVecBuffer = interpreterProxy->stackObjectValue(2);
		argOffsets = interpreterProxy->stackObjectValue(3);
		argVecBuffer = interpreterProxy->stackObjectValue(4);
		stdErr = interpreterProxy->stackObjectValue(5);
		stdOut = interpreterProxy->stackObjectValue(6);
		stdIn = interpreterProxy->stackObjectValue(7);

		/* If a new working directory has been specified, try to chdir() to it. */

		executableFile = interpreterProxy->stackObjectValue(8);
		if (workingDir != (interpreterProxy->nilObject())) {
			pwdPtr = interpreterProxy->firstIndexableField(workingDir);
			if (pwdPtr == 0) {
				fprintf(stderr, "bad workingDir parameter\n");
				exit(-1);
			} else {
				pwd = chdir(pwdPtr);
				if (pwd != 0) {
					perror("chdir");
					exit(-1);
				}
			}
		}

		/* Dup the file handles to attach the new child process to the right streams
			on descriptors 0, 1 and 2. */

		progNamePtr = interpreterProxy->arrayValueOf(executableFile);
		if (!(stdErr == (interpreterProxy->nilObject()))) {
			dupToStdErr(stdErr);
		}
		if (!(stdOut == (interpreterProxy->nilObject()))) {
			dupToStdOut(stdOut);
		}
		if (!(stdIn == (interpreterProxy->nilObject()))) {
			dupToStdIn(stdIn);
		}

		/* First Unix file descriptor after stdin, stdout, stderr. */

		idx = 3;
		handleCount = descriptorTableSize();
		while (idx < handleCount) {
			close(idx);
			idx += 1;
		}
		if (envVecBuffer == (interpreterProxy->nilObject())) {
			env = envVec;
		} else {
			envCount = interpreterProxy->stSizeOf(envOffsets);
			envPtr = interpreterProxy->arrayValueOf(envVecBuffer);
			envOffsetPtr = interpreterProxy->firstIndexableField(envOffsets);
			fixPointersInArrayOfStringswithOffsetscount(envPtr, envOffsetPtr, envCount);
			env = ((char **) envPtr);
		}
		argCount = interpreterProxy->stSizeOf(argOffsets);
		argsPtr = interpreterProxy->arrayValueOf(argVecBuffer);
		argOffsetPtr = interpreterProxy->firstIndexableField(argOffsets);
		fixPointersInArrayOfStringswithOffsetscount(argsPtr, argOffsetPtr, argCount);

		/* Clean things up before clobbering the running image. */
		/* Release shared memory for bitmap, if any. This is specific to the Unix/X
			version of Squeak. */

		args = ((char **) argsPtr);
		
#ifdef USE_XSHM
		(void *) shmExit();
#endif
		/* Extra semicolon here is an artifact of Squeak C translation */	;
		restoreDefaultSignalHandlers();
		if ((execve(progNamePtr, args, env)) == -1) {
			perror(progNamePtr);
			exit(-1);
		} else {
			/* Can't get here from there */;
		}
	} else {
		setitimer (ITIMER_REAL, &saveIntervalTimer, 0L);
		interpreterProxy->pop(10);
		interpreterProxy->pushInteger(pid);
	}
}


/*	Fork a child process, and continue running squeak in the child process. Leave the
	X session connected to the parent process, but close its file descriptor for the child
	process. Do not open another X session for the child. The child is expected to avoid
	any further interaction with the screen, otherwise the child process will fail.

	The child should not depend on using existing connections to external resources. For
	example, the child may lose its connections to stdin, stdout, and stderr after its parent
	exits. */

EXPORT(void) primitiveForkHeadlessSqueak(void) {
    int pid;
    extern int forgetXDisplay();
    struct itimerval intervalTimer;
    extern int synchronizeXDisplay();
    struct itimerval saveIntervalTimer;

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(1);
		interpreterProxy->pushInteger(-1);
	}
	intervalTimer.it_interval.tv_sec = 0;
	intervalTimer.it_interval.tv_usec = 0;
	intervalTimer.it_value.tv_sec = 0;
	intervalTimer.it_value.tv_usec = 0;
	setitimer (ITIMER_REAL, &intervalTimer, &saveIntervalTimer);
	synchronizeXDisplay();
	setSigChldHandler();
	pid = fork();
	if (pid == 0) {
		forgetXDisplay();
		/* Child process does not yet have its own window, so we just */;
		/* need to forget about the parent's window here. */;
	}
	setitimer (ITIMER_REAL, &saveIntervalTimer, 0L);
	interpreterProxy->pop(1);
	interpreterProxy->pushInteger(pid);
}


/*	Fork a child process, and continue running squeak in the child process. After calling
	fork(), two OS processes exist, one of which is the child of the other. On systems
	which implement copy-on-write memory management, and which support the fork()
	system call, both processes will be running Smalltalk images, and will be sharing the
	same memory space. In the original OS process, the resulting value of pid is the process
	id of the child process (a non-zero integer). In the child process, the value of pid is zero.

	The child recreates sufficient external resources to continue running. This is done by
	attaching to a new X session. The child is otherwise a copy of the parent process, and
	will continue executing the Smalltalk image at the same point as its parent. The return
	value of this primitive may be used by the two running Smalltalk images to determine
	which is the parent and which is the child.

	The child should not depend on using existing connections to external resources. For
	example, the child may lose its connections to stdin, stdout, and stderr after its parent
	exits.

	The new child image does not start itself from the image in the file system; rather it is
	a clone of the parent image as it existed at the time of primitiveForkSqueak. For this
	reason, the parent and child should agree in advance as to whom is allowed to save the
	image to the file system, otherwise one Smalltalk may overwrite the image of the other.

	This is a simple call to fork(), rather than the more common idiom of vfork() followed
	by exec(). The vfork() call cannot be used here because it is designed to be followed by
	an exec(), and its semantics require the parent process to wait for the child to exit. See
	the BSD programmers documentation for details. */

EXPORT(void) primitiveForkSqueak(void) {
    int pid;
    extern int forgetXDisplay();
    struct itimerval intervalTimer;
    extern int synchronizeXDisplay();
    struct itimerval saveIntervalTimer;
    extern int openXDisplay();

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(1);
		interpreterProxy->pushInteger(-1);
	}
	intervalTimer.it_interval.tv_sec = 0;
	intervalTimer.it_interval.tv_usec = 0;
	intervalTimer.it_value.tv_sec = 0;
	intervalTimer.it_value.tv_usec = 0;
	setitimer (ITIMER_REAL, &intervalTimer, &saveIntervalTimer);
	synchronizeXDisplay();
	setSigChldHandler();
	pid = fork();
	if (pid == 0) {
		forgetXDisplay();
		openXDisplay();
	}
	setitimer (ITIMER_REAL, &saveIntervalTimer, 0L);
	interpreterProxy->pop(1);
	interpreterProxy->pushInteger(pid);
}


/*	Answer a string containing the current working directory. Assume that
	the string will fit in a buffer of size 1024. */

EXPORT(void) primitiveGetCurrentWorkingDirectory(void) {
    int incrementBy;
    int bufferSize;
    char *buffer;
    char *cwd;
    int maxSize;
    int cwdString;

	bufferSize = 100;
	incrementBy = 100;
	maxSize = 5000;
	while (1) {
		cwdString = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classString(), bufferSize);
		buffer = interpreterProxy->arrayValueOf(cwdString);
		cwd = getcwd(buffer, bufferSize);
		if (!((cwd == 0) && (bufferSize < maxSize))) break;
		bufferSize += incrementBy;
	}
	if (cwd == 0) {
		interpreterProxy->primitiveFail();
		interpreterProxy->pop(1);
		interpreterProxy->push(interpreterProxy->nilObject());
	} else {
		cwdString = stringFromCString(cwd);
		interpreterProxy->pop(1);
		interpreterProxy->push(cwdString);
	}
}


/*	Answer the effective group ID of my OS process */

EXPORT(void) primitiveGetEGid(void) {
    int eGid;

	eGid = getegid();
	interpreterProxy->pop(1);
	interpreterProxy->pushInteger(eGid);
}


/*	Answer the effective user ID of my OS process */

EXPORT(void) primitiveGetEUid(void) {
    int eUid;

	eUid = geteuid();
	interpreterProxy->pop(1);
	interpreterProxy->pushInteger(eUid);
}


/*	Answer the group ID of my OS process */

EXPORT(void) primitiveGetGid(void) {
    int gid;

	gid = getgid();
	interpreterProxy->pop(1);
	interpreterProxy->pushInteger(gid);
}


/*	Answer the process ID of the parent process of my OS process */

EXPORT(void) primitiveGetPPid(void) {
    int ppid;

	ppid = getppid();
	interpreterProxy->pop(1);
	interpreterProxy->pushInteger(ppid);
}


/*	Answer the process ID of my OS process */

EXPORT(void) primitiveGetPid(void) {
    int pid;

	pid = getpid();
	interpreterProxy->pop(1);
	interpreterProxy->pushInteger(pid);
}


/*	Answer the unique session identifier for this Smalltalk instance running in this OS process.
	The C integer value is coerced into a four byte Smalltalk ByteArray to preserve the full
	32 bit range of possible values. */

EXPORT(void) primitiveGetSession(void) {
    extern int thisSession;
    int idx;
    char *sessionByteArrayPointer;
    int sessionOop;
    union {int i; unsigned char c[4];} u;

	sessionOop = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), 4);
	sessionByteArrayPointer = interpreterProxy->arrayValueOf(sessionOop);
	u.i = thisSession;
	for (idx=0; idx<4; idx++) *(sessionByteArrayPointer + idx) = u.c[idx];
	interpreterProxy->pop(1);
	interpreterProxy->push(sessionOop);
}


/*	Answer the file handle for standard error of my OS process */

EXPORT(void) primitiveGetStdErrHandle(void) {
    extern int thisSession;
    int fileOop;
    SQFile * file;

	fileOop = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), fileRecordSize());
	/* begin fileValueOf: */
	if ((interpreterProxy->isBytes(fileOop)) && ((interpreterProxy->byteSizeOf(fileOop)) == (fileRecordSize()))) {
		file = arrayValueOf(fileOop);
		goto l1;
	} else {
		primitiveFail();
		file = null;
		goto l1;
	}
l1:	/* end fileValueOf: */;
	file->file = stderr;
	file->sessionID = thisSession;
	file->writable = 1;
	file->lastOp = 0;
	interpreterProxy->pop(1);
	interpreterProxy->push(fileOop);
}


/*	Answer the file handle for standard input of my OS process */

EXPORT(void) primitiveGetStdInHandle(void) {
    extern int thisSession;
    int fileOop;
    SQFile * file;

	fileOop = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), fileRecordSize());
	/* begin fileValueOf: */
	if ((interpreterProxy->isBytes(fileOop)) && ((interpreterProxy->byteSizeOf(fileOop)) == (fileRecordSize()))) {
		file = arrayValueOf(fileOop);
		goto l1;
	} else {
		primitiveFail();
		file = null;
		goto l1;
	}
l1:	/* end fileValueOf: */;
	file->file = stdin;
	file->sessionID = thisSession;
	file->writable = 0;
	file->lastOp = 0;
	interpreterProxy->pop(1);
	interpreterProxy->push(fileOop);
}


/*	Answer the file handle for standard output of my OS process */

EXPORT(void) primitiveGetStdOutHandle(void) {
    extern int thisSession;
    int fileOop;
    SQFile * file;

	fileOop = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), fileRecordSize());
	/* begin fileValueOf: */
	if ((interpreterProxy->isBytes(fileOop)) && ((interpreterProxy->byteSizeOf(fileOop)) == (fileRecordSize()))) {
		file = arrayValueOf(fileOop);
		goto l1;
	} else {
		primitiveFail();
		file = null;
		goto l1;
	}
l1:	/* end fileValueOf: */;
	file->file = stdout;
	file->sessionID = thisSession;
	file->writable = 1;
	file->lastOp = 0;
	interpreterProxy->pop(1);
	interpreterProxy->push(fileOop);
}


/*	Answer the user ID of my OS process */

EXPORT(void) primitiveGetUid(void) {
    int uid;

	uid = getuid();
	interpreterProxy->pop(1);
	interpreterProxy->pushInteger(uid);
}


/*	Call an internal function which will disconnect the X display session. */

EXPORT(void) primitiveKillDisplay(void) {
    extern int disconnectXDisplay();

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(1);
		interpreterProxy->pushInteger(-1);
	}
	disconnectXDisplay();
}


/*	Create a pipe, and answer an array of two file handles for the pipe writer and reader. */

EXPORT(void) primitiveMakePipe(void) {
    extern int thisSession;
    int reader;
    int writer;
    SQFile * readerPtr;
    SQFile * writerPtr;
    int filedes[2];
    int arrayResult;

	setSigChldHandler();
	setSigPipeHandler();
	arrayResult = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classArray(), 2);
	reader = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), fileRecordSize());
	/* begin fileValueOf: */
	if ((interpreterProxy->isBytes(reader)) && ((interpreterProxy->byteSizeOf(reader)) == (fileRecordSize()))) {
		readerPtr = arrayValueOf(reader);
		goto l1;
	} else {
		primitiveFail();
		readerPtr = null;
		goto l1;
	}
l1:	/* end fileValueOf: */;
	writer = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classByteArray(), fileRecordSize());
	/* begin fileValueOf: */
	if ((interpreterProxy->isBytes(writer)) && ((interpreterProxy->byteSizeOf(writer)) == (fileRecordSize()))) {
		writerPtr = arrayValueOf(writer);
		goto l2;
	} else {
		primitiveFail();
		writerPtr = null;
		goto l2;
	}
l2:	/* end fileValueOf: */;
	if ((pipe(filedes)) == -1) {
		interpreterProxy->primitiveFail();
	} else {
		readerPtr->file = (FILE *) fdopen (filedes[0], "r");
		readerPtr->sessionID = thisSession;
		readerPtr->writable = 0;
		readerPtr->lastOp = 0;
		writerPtr->file = (FILE *) fdopen (filedes[1], "a");
		writerPtr->sessionID = thisSession;
		writerPtr->writable = 1;
		writerPtr->lastOp = 0;
		interpreterProxy->stObjectatput(arrayResult, 1, reader);
		interpreterProxy->stObjectatput(arrayResult, 2, writer);
		interpreterProxy->pop(1);
		interpreterProxy->push(arrayResult);
	}
}


/*	Call an internal function which will open the X display session. */

EXPORT(void) primitiveOpenXDisplay(void) {
    extern int openXDisplay();

	openXDisplay();
}


/*	Set an environment variable using a string of the form 'KEY=value'. Use malloc() to
	allocate a string independent of Smalltalk object memory. This prevents the string from
	being moved by the garbage collector, which would invalidate the environment string. */

EXPORT(void) primitivePutEnv(void) {
    int keyValueString;
    char *cStringPtr;

	keyValueString = interpreterProxy->stackObjectValue(0);
	cStringPtr = cStringFromString(keyValueString);
	if ((putenv(cStringPtr)) == 0) {
		interpreterProxy->pop(2);
		interpreterProxy->push(keyValueString);
	} else {
		interpreterProxy->primitiveFail();
		interpreterProxy->pop(2);
		interpreterProxy->push(interpreterProxy->nilObject());
	}
}


/*	Answer the real path for a path string as determined by realpath(). */

EXPORT(void) primitiveRealpath(void) {
    char * realpathResult;
    int s;
    int bufferSize;
    char *buffer;
    char *pathString;
    int newPathString;

	bufferSize = 512;
	pathString = cStringFromString(interpreterProxy->stackObjectValue(0));
	newPathString = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classString(), bufferSize);
	buffer = interpreterProxy->arrayValueOf(newPathString);
	realpathResult = realpath(pathString, buffer);
	if (realpathResult == 0) {
		interpreterProxy->primitiveFail();
		interpreterProxy->pop(2);
		interpreterProxy->push(interpreterProxy->nilObject());
	} else {
		s = stringFromCString(realpathResult);
		interpreterProxy->pop(2);
		interpreterProxy->push(s);
	}
}


/*	Clean up after the death of a child, and answer an array with the pid and
	the exit status of the child process. Answer nil if the pidToHandle does not exist. */

EXPORT(void) primitiveReapChildProcess(void) {
    int pidResult;
    int exitStatus;
    int pidToHandle;
    int *arrayPtr;
    int resultArray;

	pidToHandle = interpreterProxy->stackIntegerValue(0);
	pidResult = waitpid ( pidToHandle, &exitStatus, WNOHANG );
	if (pidResult <= 0) {
		interpreterProxy->pop(2);
		interpreterProxy->push(interpreterProxy->nilObject());
	} else {
		resultArray = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classArray(), 2);
		arrayPtr = interpreterProxy->firstIndexableField(resultArray);
		arrayPtr[0] = integerObjectOf(pidResult);
		arrayPtr[1] = integerObjectOf(exitStatus);
		interpreterProxy->pop(2);
		interpreterProxy->push(resultArray);
	}
}


/*	Call rename(2) to change the name or location of a file. Answer
	nil for success, or errno on failure. */

EXPORT(void) primitiveRename(void) {
    char *oldPath;
    extern int errno;
    char *newPath;

	newPath = cStringFromString(interpreterProxy->stackObjectValue(0));
	oldPath = cStringFromString(interpreterProxy->stackObjectValue(1));
	if ((rename(oldPath, newPath)) == 0) {
		interpreterProxy->pop(3);
		interpreterProxy->push(interpreterProxy->nilObject());
	} else {
		interpreterProxy->pop(3);
		interpreterProxy->pushInteger(errno);
	}
}


/*	Take a struct SQFile from the stack, and call fflush() to flush the OS stream. This flushes the
	file stream in the C library, not the stream in Smalltalk. For output streams, consider setting
	the OS stream (C library) to unbuffered output, and letting Smalltalk do all the buffering. */

EXPORT(void) primitiveSQFileFlush(void) {
    extern int thisSession;
    SQFile * sqFile;
    int retVal;
    int anSQFileRecord;

	/* begin fileValueOf: */
	anSQFileRecord = interpreterProxy->stackValue(0);
	if ((interpreterProxy->isBytes(anSQFileRecord)) && ((interpreterProxy->byteSizeOf(anSQFileRecord)) == (fileRecordSize()))) {
		sqFile = arrayValueOf(anSQFileRecord);
		goto l1;
	} else {
		primitiveFail();
		sqFile = null;
		goto l1;
	}
l1:	/* end fileValueOf: */;
	if (thisSession == (sqFile->sessionID)) {
		retVal = fflush(sqFile->file);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(retVal);
	} else {
		interpreterProxy->primitiveFail();
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Take a struct SQFile from the stack, and call fcntl() to set the file for blocking I/O. */

EXPORT(void) primitiveSQFileSetBlocking(void) {
    extern int thisSession;
    int flags;
    int sqFileOop;
    SQFile * sqFile;
    int retVal;
    int descriptor;

	sqFileOop = interpreterProxy->stackValue(0);
	/* begin fileValueOf: */
	if ((interpreterProxy->isBytes(sqFileOop)) && ((interpreterProxy->byteSizeOf(sqFileOop)) == (fileRecordSize()))) {
		sqFile = arrayValueOf(sqFileOop);
		goto l1;
	} else {
		primitiveFail();
		sqFile = null;
		goto l1;
	}
l1:	/* end fileValueOf: */;
	if (thisSession == (sqFile->sessionID)) {
		descriptor = fileDescriptorFrom(sqFileOop);
		flags = fcntl(descriptor, F_GETFL);
		retVal = fcntl(descriptor, F_SETFL, flags & ~O_NONBLOCK);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(retVal);
	} else {
		interpreterProxy->primitiveFail();
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Take a struct SQFile from the stack, and call fcntl() to set the file non-blocking. */

EXPORT(void) primitiveSQFileSetNonBlocking(void) {
    extern int thisSession;
    int flags;
    int sqFileOop;
    SQFile * sqFile;
    int retVal;
    int descriptor;

	sqFileOop = interpreterProxy->stackValue(0);
	/* begin fileValueOf: */
	if ((interpreterProxy->isBytes(sqFileOop)) && ((interpreterProxy->byteSizeOf(sqFileOop)) == (fileRecordSize()))) {
		sqFile = arrayValueOf(sqFileOop);
		goto l1;
	} else {
		primitiveFail();
		sqFile = null;
		goto l1;
	}
l1:	/* end fileValueOf: */;
	if (thisSession == (sqFile->sessionID)) {
		descriptor = fileDescriptorFrom(sqFileOop);
		flags = fcntl(descriptor, F_GETFL);
		retVal = fcntl(descriptor, F_SETFL, flags | O_NONBLOCK);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(retVal);
	} else {
		interpreterProxy->primitiveFail();
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Take a struct SQFile from the stack, and call setbuf() to set the OS file stream (implemented in
	the C library) for unbuffered I/O. Answers the result of a fflush() call, not the result of the
	setbuf() call (which is type void). This is nearly useless, but may at least provide an indicator
	that we are operating on a valid file stream. */

EXPORT(void) primitiveSQFileSetUnbuffered(void) {
    extern int thisSession;
    SQFile * sqFile;
    int retVal;
    int anSQFileRecord;

	/* begin fileValueOf: */
	anSQFileRecord = interpreterProxy->stackValue(0);
	if ((interpreterProxy->isBytes(anSQFileRecord)) && ((interpreterProxy->byteSizeOf(anSQFileRecord)) == (fileRecordSize()))) {
		sqFile = arrayValueOf(anSQFileRecord);
		goto l1;
	} else {
		primitiveFail();
		sqFile = null;
		goto l1;
	}
l1:	/* end fileValueOf: */;
	if (thisSession == (sqFile->sessionID)) {
		retVal = fflush(sqFile->file);
		setbuf(sqFile->file, NULL);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(retVal);
	} else {
		interpreterProxy->primitiveFail();
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Send SIGABRT (abort) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number). */

EXPORT(void) primitiveSendSigabrtTo(int anIntegerPid) {
    int pidToSignal;
    int result;

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
	if (((interpreterProxy->stackValue(0)) & 1)) {
		pidToSignal = interpreterProxy->stackIntegerValue(0);
		result = kill(pidToSignal, SIGABRT);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(result);
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Send SIGALRM (alarm clock) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number). */

EXPORT(void) primitiveSendSigalrmTo(int anIntegerPid) {
    int pidToSignal;
    int result;

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
	if (((interpreterProxy->stackValue(0)) & 1)) {
		pidToSignal = interpreterProxy->stackIntegerValue(0);
		result = kill(pidToSignal, SIGALRM);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(result);
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Send SIGCHLD (child status has changed, usually death of child) to the OS process
	identified by anIntegerPid. Use an explicit check for isIntegerObject so we can
	return -1 on error (the stackIntegerValue: method answers 1 on error, and 1 is a
	valid pid number). */

EXPORT(void) primitiveSendSigchldTo(int anIntegerPid) {
    int pidToSignal;
    int result;

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
	if (((interpreterProxy->stackValue(0)) & 1)) {
		pidToSignal = interpreterProxy->stackIntegerValue(0);
		result = kill(pidToSignal, SIGCHLD);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(result);
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Send SIGCONT (continue) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number). */

EXPORT(void) primitiveSendSigcontTo(int anIntegerPid) {
    int pidToSignal;
    int result;

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
	if (((interpreterProxy->stackValue(0)) & 1)) {
		pidToSignal = interpreterProxy->stackIntegerValue(0);
		result = kill(pidToSignal, SIGCONT);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(result);
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Send SIGHUP (hangup) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number). */

EXPORT(void) primitiveSendSighupTo(int anIntegerPid) {
    int pidToSignal;
    int result;

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
	if (((interpreterProxy->stackValue(0)) & 1)) {
		pidToSignal = interpreterProxy->stackIntegerValue(0);
		result = kill(pidToSignal, SIGHUP);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(result);
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Send SIGINT (interrupt) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number). */

EXPORT(void) primitiveSendSigintTo(int anIntegerPid) {
    int pidToSignal;
    int result;

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
	if (((interpreterProxy->stackValue(0)) & 1)) {
		pidToSignal = interpreterProxy->stackIntegerValue(0);
		result = kill(pidToSignal, SIGINT);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(result);
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Send SIGKILL (kill, unblockable) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number). */

EXPORT(void) primitiveSendSigkillTo(int anIntegerPid) {
    int pidToSignal;
    int result;

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
	if (((interpreterProxy->stackValue(0)) & 1)) {
		pidToSignal = interpreterProxy->stackIntegerValue(0);
		result = kill(pidToSignal, SIGKILL);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(result);
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Send SIGPIPE (broken pipe) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number). */

EXPORT(void) primitiveSendSigpipeTo(int anIntegerPid) {
    int pidToSignal;
    int result;

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
	if (((interpreterProxy->stackValue(0)) & 1)) {
		pidToSignal = interpreterProxy->stackIntegerValue(0);
		result = kill(pidToSignal, SIGPIPE);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(result);
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Send SIGQUIT (quit) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number). */

EXPORT(void) primitiveSendSigquitTo(int anIntegerPid) {
    int pidToSignal;
    int result;

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
	if (((interpreterProxy->stackValue(0)) & 1)) {
		pidToSignal = interpreterProxy->stackIntegerValue(0);
		result = kill(pidToSignal, SIGQUIT);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(result);
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Send SIGSTOP (stop, unblockable) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number). */

EXPORT(void) primitiveSendSigstopTo(int anIntegerPid) {
    int pidToSignal;
    int result;

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
	if (((interpreterProxy->stackValue(0)) & 1)) {
		pidToSignal = interpreterProxy->stackIntegerValue(0);
		result = kill(pidToSignal, SIGSTOP);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(result);
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Send SIGTERM (termination) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number). */

EXPORT(void) primitiveSendSigtermTo(int anIntegerPid) {
    int pidToSignal;
    int result;

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
	if (((interpreterProxy->stackValue(0)) & 1)) {
		pidToSignal = interpreterProxy->stackIntegerValue(0);
		result = kill(pidToSignal, SIGTERM);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(result);
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Send SIGUSR1 (User-defined signal 1) to the OS process identified by anIntegerPid. Use
	an explicit check for isIntegerObject so we can return -1 on error (the stackIntegerValue:
	method answers 1 on error, and 1 is a valid pid number). */

EXPORT(void) primitiveSendSigusr1To(int anIntegerPid) {
    int pidToSignal;
    int result;

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
	if (((interpreterProxy->stackValue(0)) & 1)) {
		pidToSignal = interpreterProxy->stackIntegerValue(0);
		result = kill(pidToSignal, SIGUSR1);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(result);
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Send SIGUSR2 (User-defined signal 2) to the OS process identified by anIntegerPid. Use
	an explicit check for isIntegerObject so we can return -1 on error (the stackIntegerValue:
	method answers 1 on error, and 1 is a valid pid number). */

EXPORT(void) primitiveSendSigusr2To(int anIntegerPid) {
    int pidToSignal;
    int result;

	if ((sandboxSecurity()) == 1) {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
	if (((interpreterProxy->stackValue(0)) & 1)) {
		pidToSignal = interpreterProxy->stackIntegerValue(0);
		result = kill(pidToSignal, SIGUSR2);
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(result);
	} else {
		interpreterProxy->pop(2);
		interpreterProxy->pushInteger(-1);
	}
}


/*	Set the index of the semaphore used by the OSProcess with which I collaborate. My
	OSProcess should set this value so that I can use it when handling SIGCHLD signals
	(death of child). In the C translation this is a static int which would be shared by all
	instances of UnixOSProcessPlugin, which is expected to be a singleton. Answer the
	value of the semaphore index. */

EXPORT(void) primitiveSetSemaIndex(void) {
	sigChldSemaIndex = interpreterProxy->stackIntegerValue(0);
	interpreterProxy->pop(2);
	interpreterProxy->pushInteger(sigChldSemaIndex);
}


/*	Size in bytes of an integer, for this C compiler on this machine. */

EXPORT(int) primitiveSizeOfInt(void) {
    int intSize;

	intSize = sizeof(int);
	interpreterProxy->pop(1);
	interpreterProxy->pushInteger(intSize);
}


/*	Size in bytes of a void pointer, for this C compiler on this machine. */

EXPORT(int) primitiveSizeOfPointer(void) {
    int voidPtrSize;

	voidPtrSize = sizeof(void *);
	interpreterProxy->pop(1);
	interpreterProxy->pushInteger(voidPtrSize);
}


/*	Close a file handle at the close(2) level, using a handle returned by
	#primitiveUnixFileNumber. */

EXPORT(int) primitiveUnixFileClose(int anIntegerFileNumber) {
    int handle;
    int result;

	handle = interpreterProxy->stackIntegerValue(0);
	result = close(handle);
	interpreterProxy->pop(2);
	interpreterProxy->pushInteger(result);
}


/*	Take a struct SQFile from the stack, and answer the value of its Unix file number.
	The Unix file number is not directly useful to Squeak, but may be interesting for
	debugging problems involving failure to close unused file handles. */

EXPORT(int) primitiveUnixFileNumber(void) {
    SQFile * sqFile;
    int fileNo;
    int anSQFileRecord;

	/* begin fileValueOf: */
	anSQFileRecord = interpreterProxy->stackValue(0);
	if ((interpreterProxy->isBytes(anSQFileRecord)) && ((interpreterProxy->byteSizeOf(anSQFileRecord)) == (fileRecordSize()))) {
		sqFile = arrayValueOf(anSQFileRecord);
		goto l1;
	} else {
		primitiveFail();
		sqFile = null;
		goto l1;
	}
l1:	/* end fileValueOf: */;
	fileNo = fileno(sqFile->file);
	interpreterProxy->pop(2);
	interpreterProxy->pushInteger(fileNo);
}


/*	This is a signal handler for SIGCHLD. It is not meant to be called from Smalltalk,
	and should only be called indirectly as a result of a death of child signal from
	the operating system.

	Child processes must be cleaned up by the parent, otherwise they continue
	to exist as zombies until the parent exits. This handler resets the signal handler
	to catch the next SIGCHLD signal, then sets a semaphore to notify the system
	that a child process needs to be cleaned up. The actual clean up is done by a
	Smalltalk process which waits on the semaphore, then calls primitiveReapChildProcess.

	Note: If child processes die faster than we can clean them up, signals will be lost
	and child processes will remain as zombies. */

static void reapChildProcess(int sigNum) {
	setSigChldHandler();
	if (sigChldSemaIndex > 0) {
		signalSemaphoreWithIndex(sigChldSemaIndex);
	}
}


/*	Restore signal handlers to their default behaviors. */

static void restoreDefaultSignalHandlers(void) {
	if (signal(SIGPIPE, SIG_DFL) == SIG_ERR) { perror("signal"); }
	if (signal(SIGCHLD, SIG_DFL) == SIG_ERR) { perror("signal"); }
}


/*	Answer 1 if running in secure mode, else 0. */

static int sandboxSecurity(void) {
    extern int secure;

	return secure;
}


/*	Note: This is coded so that is can be run from Squeak. */

EXPORT(int) setInterpreter(struct VirtualMachine* anInterpreter) {
    int ok;

	interpreterProxy = anInterpreter;
	ok = interpreterProxy->majorVersion() == VM_PROXY_MAJOR;
	if (ok == 0) {
		return 0;
	}
	ok = interpreterProxy->minorVersion() >= VM_PROXY_MINOR;
	return ok;
}


/*	Set the SIGCHLD signal handler in the virtual machine. */

static void setSigChldHandler(void) {
	if (signal(SIGCHLD, reapChildProcess) == SIG_ERR) { perror("signal"); }
}


/*	Set the SIGPIPE signal handler in the virtual machine to ignore pipe error signals.
	If a pipe is opened to a child process, and the child exits, then subsequent writes to
	the pipe generate a SIGPIPE signal. If this signal is not handled, the VM will exit
	without warning. */

static void setSigPipeHandler(void) {
	if (signal(SIGPIPE, SIG_IGN) == SIG_ERR) { perror("signal"); }
}


/*	Answer the size of a SQSocket data structure in bytes. */

static int socketRecordSize(void) {
	return sizeof(SQSocket);
}


/*	Return a pointer to the first byte of of the SQsocket data structure socket record within
	anSQSocketRecord, which is expected to be a ByteArray of size self>>socketRecordSize. */

static SQSocket * socketValueOf(int anSQSocketRecord) {
	if ((interpreterProxy->isBytes(anSQSocketRecord)) && ((interpreterProxy->byteSizeOf(anSQSocketRecord)) == (socketRecordSize()))) {
		return arrayValueOf(anSQSocketRecord);
	} else {
		primitiveFail();
		return null;
	}
}


/*	Answer a new String copied from a null-terminated C string.
	Caution: This may invoke the garbage collector. */

static int stringFromCString(char *aCString) {
    int newString;
    char *stringPtr;
    int len;

	len = strlen(aCString);
	newString = interpreterProxy->instantiateClassindexableSize(interpreterProxy->classString(), len);
	stringPtr = interpreterProxy->arrayValueOf(newString);
	(char *)strncpy(stringPtr, aCString, len);
	return newString;
}
